# Generated by Django 2.1 on 2019-05-23 14:51

from arkindex_common.enums import EntityType
import django.contrib.postgres.fields.hstore
from django.contrib.postgres.operations import HStoreExtension
from django.db import migrations, models
import django.db.models.deletion
import enumfields.fields
import uuid


class Migration(migrations.Migration):

    dependencies = [
        ('documents', '0002_interpreteddate'),
    ]

    operations = [
        HStoreExtension(),
        migrations.CreateModel(
            name='Entity',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ('name', models.TextField()),
                ('type', enumfields.fields.EnumField(
                    db_index=True,
                    enum=EntityType,
                    max_length=50)),
                ('metas', django.contrib.postgres.fields.hstore.HStoreField(blank=True, null=True)),
                ('corpus', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='entities',
                    to='documents.Corpus')),
            ],
            options={
                'verbose_name_plural': 'Entities',
            },
        ),
        migrations.CreateModel(
            name='EntityLink',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ('child', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='children',
                    to='documents.Entity')),
                ('parent', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='parents',
                    to='documents.Entity')),
            ],
        ),
        migrations.CreateModel(
            name='EntityRole',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('parent_name', models.CharField(max_length=250)),
                ('child_name', models.CharField(max_length=250)),
                ('parent_type', enumfields.fields.EnumField(enum=EntityType, max_length=50)),
                ('child_type', enumfields.fields.EnumField(enum=EntityType, max_length=50)),
                ('corpus', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='roles',
                    to='documents.Corpus')),
            ],
        ),
        migrations.AddField(
            model_name='entitylink',
            name='role',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='links',
                to='documents.EntityRole'),
        ),
        migrations.AddField(
            model_name='metadata',
            name='entity',
            field=models.ForeignKey(
                blank=True,
                null=True,
                on_delete=django.db.models.deletion.SET_NULL,
                related_name='metadatas',
                to='documents.Entity'),
        ),
        migrations.AlterUniqueTogether(
            name='entityrole',
            unique_together={('parent_name', 'child_name', 'parent_type', 'child_type', 'corpus')},
        ),
        migrations.AlterUniqueTogether(
            name='entity',
            unique_together={('corpus', 'type', 'name')},
        ),
    ]
