# Generated by Django 2.2 on 2019-07-08 09:48

from django.db import migrations, models
import django.db.models.deletion
import uuid


class Migration(migrations.Migration):

    dependencies = [
        ('images', '0007_common_md5_hash_field'),
        ('documents', '0010_entity_related_names'),
    ]

    operations = [
        migrations.CreateModel(
            name='Region',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ('confidence', models.FloatField(blank=True, null=True)),
            ],
            options={
                'default_related_name': 'regions',
            },
        ),
        migrations.CreateModel(
            name='RegionElement',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, primary_key=True, serialize=False)),
                ('ordering', models.PositiveIntegerField(default=0)),
                ('region', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='region_elements',
                    to='documents.Region',
                )),
                ('element', models.ForeignKey(
                    on_delete=django.db.models.deletion.CASCADE,
                    related_name='region_elements',
                    to='documents.Element',
                )),
            ],
            options={
                'default_related_name': 'region_elements',
                'unique_together': {('element', 'region')},
                'ordering': ('element', 'ordering'),
            },
        ),
        migrations.AddField(
            model_name='region',
            name='elements',
            field=models.ManyToManyField(
                related_name='regions',
                through='documents.RegionElement',
                to='documents.Element',
            ),
        ),
        migrations.AddField(
            model_name='region',
            name='ml_class',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='regions',
                to='documents.MLClass',
            ),
        ),
        migrations.AddField(
            model_name='region',
            name='source',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='regions',
                to='documents.DataSource',
            ),
        ),
        migrations.AddField(
            model_name='region',
            name='zone',
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name='regions',
                to='images.Zone',
            ),
        ),
    ]
